Index: trunk/source/geometry/magneticfield/src/G4MagIntegratorDriver.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4MagIntegratorDriver.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4MagIntegratorDriver.cc	(revision 1231)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4MagIntegratorDriver.cc,v 1.49 2007/08/17 12:30:33 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4MagIntegratorDriver.cc,v 1.56 2009/11/12 18:41:03 japost Exp $
+// GEANT4 tag $Name:  $
 //
 // 
@@ -53,5 +53,6 @@
 const G4double G4MagInt_Driver::max_stepping_decrease = 0.1;
 
-//  The (default) maximum number of steps is Base divided by the order of Stepper
+//  The (default) maximum number of steps is Base
+//  divided by the order of Stepper
 //
 const G4int  G4MagInt_Driver::fMaxStepBase = 250;  // Was 5000
@@ -61,10 +62,12 @@
 #endif
 
+// ---------------------------------------------------------
+
 //  Constructor
 //
 G4MagInt_Driver::G4MagInt_Driver( G4double                hminimum, 
-				  G4MagIntegratorStepper *pItsStepper,
-				  G4int                   numComponents,
-				  G4int                   statisticsVerbose)
+                                  G4MagIntegratorStepper *pItsStepper,
+                                  G4int                   numComponents,
+                                  G4int                   statisticsVerbose)
   : fSmallestFraction( 1.0e-12 ), 
     fNoIntegrationVariables(numComponents), 
@@ -72,31 +75,34 @@
     fNoVars( std::max( fNoIntegrationVariables, fMinNoVars )),
     fVerboseLevel(0),
-    fNoTotalSteps(0),  fNoBadSteps(0), fNoSmallSteps(0), fNoInitialSmallSteps(0),
-    fDyerr_max(0.0), fDyerr_mx2(0.0), 
+    fNoTotalSteps(0),  fNoBadSteps(0), fNoSmallSteps(0),
+    fNoInitialSmallSteps(0), fDyerr_max(0.0), fDyerr_mx2(0.0), 
     fDyerrPos_smTot(0.0), fDyerrPos_lgTot(0.0), fDyerrVel_lgTot(0.0), 
     fSumH_sm(0.0),   fSumH_lg(0.0),
     fStatisticsVerboseLevel(statisticsVerbose)
 {  
-// In order to accomodate "Laboratory Time", which is [7], fMinNoVars=8 is required.
-// For proper time of flight and spin,  fMinNoVars must be 12
-
-      // fNoVars= std::max( fNoVars, fMinNoVars );  
-      RenewStepperAndAdjust( pItsStepper );
-      fMinimumStep= hminimum;
-      fMaxNoSteps = fMaxStepBase / pIntStepper->IntegratorOrder();
+  // In order to accomodate "Laboratory Time", which is [7], fMinNoVars=8
+  // is required. For proper time of flight and spin,  fMinNoVars must be 12
+
+  RenewStepperAndAdjust( pItsStepper );
+  fMinimumStep= hminimum;
+  fMaxNoSteps = fMaxStepBase / pIntStepper->IntegratorOrder();
 #ifdef G4DEBUG_FIELD
-      fVerboseLevel=2;
-#endif
-
-      if( (fVerboseLevel > 0) || (fStatisticsVerboseLevel > 1) ){
-	 G4cout << "MagIntDriver version: Accur-Adv: invE_nS, QuickAdv-2sqrt with Statistics "
+  fVerboseLevel=2;
+#endif
+
+  if( (fVerboseLevel > 0) || (fStatisticsVerboseLevel > 1) )
+  {
+    G4cout << "MagIntDriver version: Accur-Adv: "
+           << "invE_nS, QuickAdv-2sqrt with Statistics "
 #ifdef G4FLD_STATS
-		<< " enabled "
+           << " enabled "
 #else
-		<< " disabled "
-#endif
-		<< G4endl;
-      }
-}
+           << " disabled "
+#endif
+           << G4endl;
+  }
+}
+
+// ---------------------------------------------------------
 
 //  Destructor
@@ -104,32 +110,30 @@
 G4MagInt_Driver::~G4MagInt_Driver()
 { 
-     if( fStatisticsVerboseLevel > 1 ){
-        PrintStatisticsReport() ;
-     }
-     // Future: for default verbose level, print an understandable summary
-}
-
-
-// To add much printing for debugging purposes, uncomment this:
+  if( fStatisticsVerboseLevel > 1 )
+  {
+    PrintStatisticsReport();
+  }
+}
+
+// To add much printing for debugging purposes, uncomment the following
+// and set verbose level to 1 or higher value !
 // #define  G4DEBUG_FIELD 1    
-// and set verbose level to 1 or higher value !
+
+// ---------------------------------------------------------
 
 G4bool
 G4MagInt_Driver::AccurateAdvance(G4FieldTrack& y_current,
-		                 G4double     hstep,
-		                 G4double     eps,
-				 G4double hinitial )
-//		     const G4double dydx[6],    // We could may add this ??
-
-// Runge-Kutta driver with adaptive stepsize control. Integrate starting
-// values at y_current over hstep x2 with accuracy eps. 
-// On output ystart is replaced by values at the end of the integration 
-// interval.  
-// RightHandSide is the right-hand side of ODE system. 
-// The source is similar to odeint routine from NRC p.721-722 .
-
-{
-  G4int nstp, i, no_warnings=0;; 
-  G4double x, hnext, hdid, h ;
+                                 G4double     hstep,
+                                 G4double     eps,
+                                 G4double hinitial )
+{
+  // Runge-Kutta driver with adaptive stepsize control. Integrate starting
+  // values at y_current over hstep x2 with accuracy eps. 
+  // On output ystart is replaced by values at the end of the integration 
+  // interval. RightHandSide is the right-hand side of ODE system. 
+  // The source is similar to odeint routine from NRC p.721-722 .
+
+  G4int nstp, i, no_warnings=0;
+  G4double x, hnext, hdid, h;
 
 #ifdef G4DEBUG_FIELD
@@ -149,9 +153,10 @@
   G4int  noFullIntegr=0, noSmallIntegr = 0 ;
   static G4int  noGoodSteps =0 ;  // Bad = chord > curve-len 
-  const  int    nvar= fNoVars;
+  const  G4int  nvar= fNoVars;
 
   G4FieldTrack yStartFT(y_current);
 
-  //  Ensure that hstep > 0 
+  //  Ensure that hstep > 0
+  //
   if( hstep <= 0.0 )
   { 
@@ -181,10 +186,11 @@
   x2= x1 + hstep;
 
-  if( (hinitial > 0.0) 
-      && (hinitial < hstep)
-      && (hinitial > perMillion * hstep) ){
+  if ( (hinitial > 0.0) && (hinitial < hstep)
+    && (hinitial > perMillion * hstep) )
+  {
      h = hinitial;
-  }else{
-     //  Initial Step size "h" defaults to the full interval
+  }
+  else  //  Initial Step size "h" defaults to the full interval
+  {
      h = hstep;
   }
@@ -192,170 +198,199 @@
   x = x1;
 
-  for(i=0;i<nvar;i++) y[i] = ystart[i] ;
-
-  G4bool  lastStep= false;
+  for (i=0;i<nvar;i++)  { y[i] = ystart[i]; }
+
+  G4bool lastStep= false;
   nstp=1;
-  // G4double  lastStepThreshold = std::min( eps * hstep, Hmin() ); 
-
-  do{
-     G4ThreeVector StartPos( y[0], y[1], y[2] );   
-#    ifdef G4DEBUG_FIELD
-       for(i=0;i<nvar;i++) ySubStepStart[i] = y[i] ;
-       yFldTrkStart.LoadFromArray(y, fNoIntegrationVariables);
-       yFldTrkStart.SetCurveLength(x);
-#    endif
-
-     pIntStepper->RightHandSide( y, dydx );
-
-     fNoTotalSteps++;
-     // Perform the Integration
-     //      
-     if( h > fMinimumStep ){ 
-        OneGoodStep(y,dydx,x,h,eps,hdid,hnext) ;
-        //--------------------------------------
-        lastStepSucceeded= (hdid == h);   
+
+  do
+  {
+    G4ThreeVector StartPos( y[0], y[1], y[2] );
+
+#ifdef G4DEBUG_FIELD
+    G4double xSubStepStart= x; 
+    for (i=0;i<nvar;i++)  { ySubStepStart[i] = y[i]; }
+    yFldTrkStart.LoadFromArray(y, fNoIntegrationVariables);
+    yFldTrkStart.SetCurveLength(x);
+#endif
+
+    // Old method - inline call to Equation of Motion
+    //   pIntStepper->RightHandSide( y, dydx );
+    // New method allows to cache field, or state (eg momentum magnitude)
+    pIntStepper->ComputeRightHandSide( y, dydx );
+    fNoTotalSteps++;
+
+    // Perform the Integration
+    //      
+    if( h > fMinimumStep )
+    { 
+      OneGoodStep(y,dydx,x,h,eps,hdid,hnext) ;
+      //--------------------------------------
+      lastStepSucceeded= (hdid == h);   
+#ifdef G4DEBUG_FIELD
+      if (dbg>2) {
+        PrintStatus( ySubStepStart, xSubStepStart, y, x, h,  nstp); // Only
+      }
+#endif
+    }
+    else
+    {
+      G4FieldTrack yFldTrk( G4ThreeVector(0,0,0), 
+                            G4ThreeVector(0,0,0), 0., 0., 0., 0. );
+      G4double dchord_step, dyerr, dyerr_len;   // What to do with these ?
+      yFldTrk.LoadFromArray(y, fNoIntegrationVariables); 
+      yFldTrk.SetCurveLength( x );
+
+      QuickAdvance( yFldTrk, dydx, h, dchord_step, dyerr_len ); 
+      //-----------------------------------------------------
+
+      yFldTrk.DumpToArray(y);    
+
+#ifdef G4FLD_STATS
+      fNoSmallSteps++; 
+      if ( dyerr_len > fDyerr_max)  { fDyerr_max= dyerr_len; }
+      fDyerrPos_smTot += dyerr_len;
+      fSumH_sm += h;  // Length total for 'small' steps
+      if (nstp<=1)  { fNoInitialSmallSteps++; }
+#endif
+#ifdef G4DEBUG_FIELD
+      if (dbg>1)
+      {
+        if(fNoSmallSteps<2) { PrintStatus(ySubStepStart, x1, y, x, h, -nstp); }
+        G4cout << "Another sub-min step, no " << fNoSmallSteps 
+               << " of " << fNoTotalSteps << " this time " << nstp << G4endl; 
+        PrintStatus( ySubStepStart, x1, y, x, h,  nstp);   // Only this
+        G4cout << " dyerr= " << dyerr_len << " relative = " << dyerr_len / h 
+               << " epsilon= " << eps << " hstep= " << hstep 
+               << " h= " << h << " hmin= " << fMinimumStep << G4endl;
+      }
+#endif        
+      if( h == 0.0 )
+      { 
+        G4Exception("G4MagInt_Driver::AccurateAdvance()",
+                    "Integration Step became Zero",
+                    FatalException, "IntegrationStepUnderflow."); 
+      }
+      dyerr = dyerr_len / h;
+      hdid= h;
+      x += hdid;
+
+      // Compute suggested new step
+      hnext= ComputeNewStepSize( dyerr/eps, h);
+
+      // .. hnext= ComputeNewStepSize_WithinLimits( dyerr/eps, h);
+      lastStepSucceeded= (dyerr<= eps);
+    }
+
+    if (lastStepSucceeded)  { noFullIntegr++; }
+    else                    { noSmallIntegr++; }
+
+    G4ThreeVector EndPos( y[0], y[1], y[2] );
+
 #ifdef  G4DEBUG_FIELD
-  	  if(dbg>2) PrintStatus( ySubStepStart, xSubStart, y, x, h,  nstp); // Only
-#endif
-     }else{
-        G4FieldTrack yFldTrk( G4ThreeVector(0,0,0), 
-			      G4ThreeVector(0,0,0), 0., 0., 0., 0. );
-        G4double dchord_step, dyerr, dyerr_len;  //  Must figure what to do with these
-	yFldTrk.LoadFromArray(y, fNoIntegrationVariables); 
-        yFldTrk.SetCurveLength( x );
-
-        QuickAdvance( yFldTrk, dydx, h, dchord_step, dyerr_len ); 
-        //-----------------------------------------------------
-        // #ifdef G4DEBUG_FIELD
-	// if(dbg>1) OneGoodStep(y,dydx,x,h,2*eps,hdid,hnext) ;
-	// if(dbg>1) PrintStatus( ystart, x1, y, x, h, -nstp);  
-
-        yFldTrk.DumpToArray(y);    
-
-#ifdef G4FLD_STATS
-	fNoSmallSteps++; 
-        if( dyerr_len > fDyerr_max) fDyerr_max= dyerr_len;
-        fDyerrPos_smTot += dyerr_len;
-	fSumH_sm += h;  // Length total for 'small' steps
-        if(nstp<=1) fNoInitialSmallSteps++;
-#endif
+    if( (dbg>0) && (dbg<=2) && (nstp>nStpPr))
+    {
+      if( nstp==nStpPr )  { G4cout << "***** Many steps ****" << G4endl; }
+      G4cout << "MagIntDrv: " ; 
+      G4cout << "hdid="  << std::setw(12) << hdid  << " "
+             << "hnext=" << std::setw(12) << hnext << " " 
+	     << "hstep=" << std::setw(12) << hstep << " (requested) " 
+	     << G4endl;
+      PrintStatus( ystart, x1, y, x, h, (nstp==nStpPr) ? -nstp: nstp); 
+    }
+#endif
+
+    // Check the endpoint
+    G4double endPointDist= (EndPos-StartPos).mag(); 
+    if ( endPointDist >= hdid*(1.+perMillion) )
+    {
+      fNoBadSteps++;
+
+      // Issue a warning only for gross differences -
+      // we understand how small difference occur.
+      if ( endPointDist >= hdid*(1.+perThousand) )
+      { 
 #ifdef G4DEBUG_FIELD
-	if(dbg>1) {
-	   if(fNoSmallSteps<2) PrintStatus( ySubStepStart, x1, y, x, h, -nstp);
-	   G4cout << "Another sub-min step, no " << fNoSmallSteps 
-		  << " of " << fNoTotalSteps << " this time " << nstp << G4endl; 
-	   PrintStatus( ySubStepStart, x1, y, x, h,  nstp);   // Only this
-	   G4cout << " dyerr= " << dyerr_len << " relative = " << dyerr_len / h 
-		  << " epsilon= " << eps << " hstep= " << hstep 
-		  << " h= " << h << " hmin= " << fMinimumStep
-		  << G4endl;
+        if (dbg)
+        {
+          WarnEndPointTooFar ( endPointDist, hdid, eps, dbg ); 
+          G4cerr << "  Total steps:  bad " << fNoBadSteps
+                 << " good " << noGoodSteps << " current h= " << hdid
+                 << G4endl;
+          PrintStatus( ystart, x1, y, x, hstep, no_warnings?nstp:-nstp);  
         }
-#endif	
-	if( h == 0.0 ) { 
-	   G4Exception("G4MagInt_Driver::AccurateAdvance()", "Integration Step became Zero",
-		       FatalException, "IntegrationStepUnderflow."); 
-	}
-	dyerr = dyerr_len / h;
-	hdid= h;
-        x += hdid;
-        // Compute suggested new step
-	hnext= ComputeNewStepSize( dyerr/eps, h);
-	// .. hnext= ComputeNewStepSize_WithinLimits( dyerr/eps, h);
-	lastStepSucceeded= (dyerr<= eps);
-     }
-
-     if(lastStepSucceeded) noFullIntegr++ ; else noSmallIntegr++ ;
-     G4ThreeVector EndPos( y[0], y[1], y[2] );
-
+#endif
+        no_warnings++;
+      }
+    }
+    else
+    {
+      noGoodSteps ++;
+    } 
+// #endif
+
+    //  Avoid numerous small last steps
+    if( (h < eps * hstep) || (h < fSmallestFraction * startCurveLength) )
+    {
+      // No more integration -- the next step will not happen
+      lastStep = true;  
+    }
+    else
+    {
+      // Check the proposed next stepsize
+      if(std::fabs(hnext) <= Hmin())
+      {
 #ifdef  G4DEBUG_FIELD
-     if( (dbg>0) && (dbg<=2) && (nstp>nStpPr)) {
-       if( nstp==nStpPr ) G4cout << "***** Many steps ****" << G4endl;
-       G4cout << "hdid="  << std::setw(12) << hdid  << " "
-	      << "hnext=" << std::setw(12) << hnext << " " << G4endl;
-       PrintStatus( ystart, x1, y, x, h, (nstp==nStpPr) ? -nstp: nstp); 
-     }
-#endif
-
-     // Check the endpoint
-     G4double endPointDist= (EndPos-StartPos).mag(); 
-     if( endPointDist >= hdid*(1.+perMillion) ){
-        fNoBadSteps  ++;
-        // Issue a warning only for gross differences -
-        //   we understand how small difference occur.
-        if( endPointDist >= hdid*(1.+perThousand) ){ 
-#ifdef  G4DEBUG_FIELD
-           if(dbg){
-	      WarnEndPointTooFar ( endPointDist, hdid, eps, dbg ); 
-	      G4cerr << "  Total steps:  bad " << fNoBadSteps << " good " << noGoodSteps << " current h= " << hdid << G4endl;
-	      // G4cerr << "Mid:EndPtFar> ";
-	      PrintStatus( ystart, x1, y, x, hstep, no_warnings?nstp:-nstp);  
-                // Potentially add as arguments:  <dydx> - as Initial Force
-           }
-#endif
-	   no_warnings++;
-	}
-     } else { // ie (!dbg)
-        noGoodSteps ++;
-     } 
-// #endif
-
-     //  Avoid numerous small last steps
-     if( (h < eps * hstep) || (h < fSmallestFraction * startCurveLength) ) {
-       // No more integration -- the next step will not happen
-       lastStep = true;  
-       // fNoLastStep++; 
-     } else {
-
-        // Check the proposed next stepsize
-        if(std::fabs(hnext) <= Hmin())
+        // If simply a very small interval is being integrated, do not warn
+        if( (x < x2 * (1-eps) ) &&        // The last step can be small: OK
+            (std::fabs(hstep) > Hmin()) ) // and if we are asked, it's OK
         {
-#ifdef  G4DEBUG_FIELD
-           // If simply a very small interval is being integrated, do not warn
-	   if( (x < x2 * (1-eps) ) &&     //  The last step can be small: it's OK
-               (std::fabs(hstep) > Hmin())     //   and if we are asked, it's OK
-               //   && (hnext < hstep * PerThousand ) 
-	     )
-           {
-             if(dbg>0){    // G4cerr << "Mid:SmallStep> ";
-		WarnSmallStepSize( hnext, hstep, h, x-x1, nstp );  
-		PrintStatus( ystart, x1, y, x, hstep, no_warnings?nstp:-nstp);
-	     }
-	     no_warnings++;
-	   }
-#endif
-	   // Make sure that the next step is at least Hmin.
-	   h = Hmin();
-	}else{
-	   h = hnext ;
-	}
-
-        //  Ensure that the next step does not overshoot
-        if( x+h > x2 ) {
-           h = x2 - x ;     // When stepsize overshoots, decrease it!
-           //  Must cope with difficult rounding-error issues if hstep << x2
-	}
-        // if( h < smallestFraction * startCurveLength )
-	if( h == 0.0 ){
-	  // Cannot progress - accept this as last step - by default
-	  lastStep = true;
-#ifdef  G4DEBUG_FIELD
-           if(dbg){
-	     G4cout << "Warning: G4MagIntegratorDriver::AccurateAdvance" << G4endl
-	            << "  Integration step 'h' became " << h << " due to roundoff " << G4endl
-		    << "  Forcing termination of advance." << G4endl;
-	   }	  
-#endif
-	}
-     }
-
-  }while ( ((nstp++)<=fMaxNoSteps)
-          && (x < x2)           //  Have we reached the end ?
-                                //   --> a better test might be x-x2 > an_epsilon
-          && (!lastStep)
-         );
+          if(dbg>0)
+          {
+            WarnSmallStepSize( hnext, hstep, h, x-x1, nstp );  
+            PrintStatus( ystart, x1, y, x, hstep, no_warnings?nstp:-nstp);
+          }
+          no_warnings++;
+        }
+#endif
+        // Make sure that the next step is at least Hmin.
+        h = Hmin();
+      }
+      else
+      {
+        h = hnext;
+      }
+
+      //  Ensure that the next step does not overshoot
+      if ( x+h > x2 )
+      {                // When stepsize overshoots, decrease it!
+        h = x2 - x ;   // Must cope with difficult rounding-error
+      }                // issues if hstep << x2
+
+      if ( h == 0.0 )
+      {
+        // Cannot progress - accept this as last step - by default
+        lastStep = true;
+#ifdef G4DEBUG_FIELD
+        if (dbg>2)
+        {
+          int prec= G4cout.precision(12); 
+          G4cout << "Warning: G4MagIntegratorDriver::AccurateAdvance"
+                 << G4endl
+                 << "  Integration step 'h' became "
+                 << h << " due to roundoff. " << G4endl
+		 << " Calculated as difference of x2= "<< x2 << " and x=" << x
+                 << "  Forcing termination of advance." << G4endl;
+          G4cout.precision(prec);
+        }          
+#endif
+      }
+    }
+  } while ( ((nstp++)<=fMaxNoSteps) && (x < x2) && (!lastStep) );
+     // Have we reached the end ?
+     // --> a better test might be x-x2 > an_epsilon
 
   succeeded=  (x>=x2);  // If it was a "forced" last step
 
-  for(i=0;i<nvar;i++)  yEnd[i] = y[i] ;
+  for (i=0;i<nvar;i++)  { yEnd[i] = y[i]; }
 
   // Put back the values.
@@ -363,119 +398,132 @@
   y_current.SetCurveLength( x );
 
-  if(nstp > fMaxNoSteps){
-     no_warnings++;
-     succeeded = false;
-#ifdef  G4DEBUG_FIELD
-        if(dbg){
-	   WarnTooManyStep( x1, x2, x );  //  Issue WARNING
-	   PrintStatus( yEnd, x1, y, x, hstep, -nstp);
-        }
-#endif
-  }
-
+  if(nstp > fMaxNoSteps)
+  {
+    no_warnings++;
+    succeeded = false;
 #ifdef G4DEBUG_FIELD
-  if( dbg && no_warnings ){
-     G4cerr << "G4MagIntegratorDriver exit status: no-steps " << nstp <<G4endl;
-     PrintStatus( yEnd, x1, y, x, hstep, nstp);
+    if (dbg)
+    {
+      WarnTooManyStep( x1, x2, x );  //  Issue WARNING
+      PrintStatus( yEnd, x1, y, x, hstep, -nstp);
+    }
+#endif
+  }
+
+#ifdef G4DEBUG_FIELD
+  if( dbg && no_warnings )
+  {
+    G4cerr << "G4MagIntegratorDriver exit status: no-steps " << nstp <<G4endl;
+    PrintStatus( yEnd, x1, y, x, hstep, nstp);
   }
 #endif
 
   return succeeded;
-
 }  // end of AccurateAdvance ...........................
+
+// ---------------------------------------------------------
 
 void
 G4MagInt_Driver::WarnSmallStepSize( G4double hnext, G4double hstep, 
-				    G4double h, G4double xDone,
-				    G4int nstp)
+                                    G4double h, G4double xDone,
+                                    G4int nstp)
 {
   static G4int noWarningsIssued =0;
   const  G4int maxNoWarnings =  10;   // Number of verbose warnings
-  if( (noWarningsIssued < maxNoWarnings) || fVerboseLevel > 10 ){
-    G4cerr<< " Warning (G4MagIntegratorDriver::AccurateAdvance): The stepsize for the " 
-	  << " next iteration=" << hnext << " is too small " 
-	  << "- in Step number " << nstp << "." << G4endl;
-    G4cerr << "     The minimum for the driver is " << Hmin()  << G4endl ;
-    G4cerr << "     Requested integr. length was " << hstep << " ." << G4endl ;
-    G4cerr << "     The size of this sub-step was " << h     << " ." << G4endl ;
-    G4cerr << "     The integrations has already gone " << xDone << G4endl ;
-  }else{
-    G4cerr<< " G4MagInt_Driver: Too small 'next' step " << hnext 
-	  << " step-no "  << nstp ;                     // << G4setw(4)
+  if( (noWarningsIssued < maxNoWarnings) || fVerboseLevel > 10 )
+  {
+    G4cerr << " Warning (G4MagIntegratorDriver::AccurateAdvance):" << G4endl
+           << " The stepsize for the next iteration, " << hnext
+           << ", is too small - in Step number " << nstp << "." << G4endl;
+    G4cerr << "     The minimum for the driver is " << Hmin()  << G4endl;
+    G4cerr << "     Requested integr. length was " << hstep << " ." << G4endl;
+    G4cerr << "     The size of this sub-step was " << h     << " ." << G4endl;
+    G4cerr << "     The integrations has already gone " << xDone << G4endl;
+  }
+  else
+  {
+    G4cerr << " G4MagInt_Driver: Too small 'next' step " << hnext 
+           << " step-no "  << nstp << G4endl;
     G4cerr << "  this sub-step " << h     
-	   << "  req_tot_len " << hstep 
-	   << "  done " << xDone 
-	   << "  min " << Hmin() 
-	   << G4endl ;
+           << "  req_tot_len " << hstep 
+           << "  done " << xDone 
+           << "  min " << Hmin() 
+           << G4endl;
   }
   noWarningsIssued++;
 }
+
+// ---------------------------------------------------------
 
 void
 G4MagInt_Driver::WarnTooManyStep( G4double x1start, 
-				  G4double x2end, 
-				  G4double xCurrent)
-{
-    G4cerr << " Warning (G4MagIntegratorDriver): The number of steps " 
-         << "used in the Integration driver (Runge-Kutta) is too many.  "
-	 << G4endl ;
-    G4cerr << "Integration of the interval was not completed - only a " 
-         << (xCurrent-x1start)*100/(x2end-x1start)
-	   <<" % fraction of it was Done." << G4endl;
-}
+                                  G4double x2end, 
+                                  G4double xCurrent)
+{
+  G4cerr << " Warning (G4MagIntegratorDriver):" << G4endl
+         << " The number of steps used in the Integration driver"
+         << " (Runge-Kutta) is too many." << G4endl;
+  G4cerr << " Integration of the interval was not completed !" << G4endl
+         << " Only a " << (xCurrent-x1start)*100/(x2end-x1start)
+         <<" % fraction of it was done." << G4endl;
+}
+
+// ---------------------------------------------------------
 
 void
 G4MagInt_Driver::WarnEndPointTooFar (G4double endPointDist, 
-				     G4double   h , 
-				     G4double  eps,
-				     G4int     dbg)
-{
-	static G4double maxRelError= 0.0, maxRelError_last_printed=0.0;
-	G4bool isNewMax, prNewMax;
-
-        isNewMax = endPointDist > (1.0 + maxRelError) * h;
-        prNewMax = endPointDist > (1.0 + 1.05 * maxRelError) * h;
-	if( isNewMax )
-	   maxRelError= endPointDist / h - 1.0; 
-        if( prNewMax )
- 	   maxRelError_last_printed = maxRelError;
-
-        if(    dbg 
-	    && (h > G4GeometryTolerance::GetInstance()->GetSurfaceTolerance()) 
-	    && ( (dbg>1) || prNewMax || (endPointDist >= h*(1.+eps) ) ) 
-          ){ 
-           static G4int noWarnings = 0;
-           if( (noWarnings ++ < 10) || (dbg>2) ){
- 	      G4cerr << " Warning (G4MagIntegratorDriver): "
-		     << " The integration produced an endpoint which " << G4endl
-		     << "   is further from the startpoint than the curve length." << G4endl; 
+                                     G4double   h , 
+                                     G4double  eps,
+                                     G4int     dbg)
+{
+  static G4double maxRelError=0.0, maxRelError_last_printed=0.0;
+  G4bool isNewMax, prNewMax;
+
+  isNewMax = endPointDist > (1.0 + maxRelError) * h;
+  prNewMax = endPointDist > (1.0 + 1.05 * maxRelError) * h;
+  if( isNewMax ) { maxRelError= endPointDist / h - 1.0; }
+  if( prNewMax ) { maxRelError_last_printed = maxRelError; }
+
+  if( dbg && (h > G4GeometryTolerance::GetInstance()->GetSurfaceTolerance()) 
+          && ( (dbg>1) || prNewMax || (endPointDist >= h*(1.+eps) ) ) )
+  { 
+    static G4int noWarnings = 0;
+    if( (noWarnings ++ < 10) || (dbg>2) )
+    {
+      G4cerr << " Warning (G4MagIntegratorDriver): " << G4endl
+             << " The integration produced an endpoint which " << G4endl
+             << "   is further from the startpoint than the curve length."
+             << G4endl; 
           
-	      G4cerr << "   Distance of endpoints = " << endPointDist
-		     << "  curve length = " <<  h
-		     << "  Difference (curveLen-endpDist)= " << (h - endPointDist)
-		     << "  relative = " << (h-endPointDist) / h 
-		     << "  epsilon =  " << eps 
-		     << G4endl;
-	   }else{
- 	      G4cerr << " Warning:" 
-		     << "  dist_e= " << endPointDist
-		     << "  h_step = " <<  h
-		     << "  Diff (hs-ed)= " << (h - endPointDist)
-		     << "  rel = " << (h-endPointDist) / h 
-		     << "  eps = " << eps
-		     << " (from G4MagInt_Driver)" << G4endl;
-	   }
-	}
-}
+      G4cerr << "   Distance of endpoints = " << endPointDist
+             << "  curve length = " <<  h
+             << "  Difference (curveLen-endpDist)= " << (h - endPointDist)
+             << "  relative = " << (h-endPointDist) / h 
+             << "  epsilon =  " << eps 
+             << G4endl;
+    }
+    else
+    {
+      G4cerr << " Warning:" 
+             << "  dist_e= " << endPointDist
+             << "  h_step = " <<  h
+             << "  Diff (hs-ed)= " << (h - endPointDist)
+             << "  rel = " << (h-endPointDist) / h 
+             << "  eps = " << eps
+             << " (from G4MagInt_Driver)" << G4endl;
+    }
+  }
+}
+
 // ---------------------------------------------------------
 
 void
 G4MagInt_Driver::OneGoodStep(      G4double y[],        // InOut
-			     const G4double dydx[],
-				   G4double& x,         // InOut
-			           G4double htry,
-			           G4double eps_rel_max,
-				   G4double& hdid,      // Out
-				   G4double& hnext )    // Out
+                             const G4double dydx[],
+                                   G4double& x,         // InOut
+                                   G4double htry,
+                                   G4double eps_rel_max,
+                                   G4double& hdid,      // Out
+                                   G4double& hnext )    // Out
 
 // Driver for one Runge-Kutta Step with monitoring of local truncation error
